<?php
/**
 * accueil de la section depot
 * @Version $Id$
 * @Projet SambaEdu
 * @auteurs  Laurent Joly
 * @note
 * @Licence Distribue sous la licence GPL
 */

// loading libs and init
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("lang.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
echo header_authorize($config);
include "ihm.inc.php";
include "wpkg_lib.php";
include "wpkg_libsql.php";
include "partages.inc.php";
include "samba.inc.php";

$login = $config['login'];
if (! $login) {
    echo "<script language=\"JavaScript\" type=\"text/javascript\">\n<!--\n";
    $request = '/wpkg/index.php';
    echo "top.location.href = '/auth.php?request=" . rawurlencode($request) . "';\n";
    echo "//-->\n</script>\n";
    exit();
}

if (! have_right($config, "computer_is_admin"))
    die(gettext("Vous n'avez pas les droits suffisants pour acc&#233;der &#224; cette fonction") . "</BODY></HTML>");

// HTMLpurifier
$conf = HTMLPurifier_Config::createDefault();
$purifier = new HTMLPurifier($conf);

// acls sur wpkg - Mise en place init en recursif

$acl_init = $config['acl_init'] ?? "0";
if ($acl_init != "1") {
    $acls = array(
        "user::rwx",
        "user:www-admin:rwx",
        "user:admin:rwx",
        "group::r-x",
        "group:domain\\040admins:r-x",
        "group:domain\\040computers:r-x",
        "mask::rwx",
        "other::---",
        "default:user::rwx",
        "default:user:www-admin:rwx",
        "default:user:admin:rwx",
        "default:group::r-x",
        "default:group:domain\\040admins:r-x",
        "default:group:domain\\040computers:r-x",
        "default:mask::rwx",
        "default:other::---"
    );
    set_acls("/var/sambaedu/unattended/install/wpkg", $acls);
    set_acls("/var/sambaedu/unattended/install/packages", $acls);

    $acls = array(
        "user::rwx",
        "user:www-admin:rwx",
        "user:admin:rwx",
        "group::r-x",
        "group:domain\\040admins:r-x",
        "group:domain\\040computers:rwx",
        "mask::rwx",
        "other::---",
        "default:user::rwx",
        "default:user:www-admin:rwx",
        "default:user:admin:rwx",
        "default:group::r-x",
        "default:group:domain\\040admins:r-x",
        "default:group:domain\\040computers:rwx",
        "default:mask::rwx",
        "default:other::---"
    );
    set_acls("/var/sambaedu/unattended/install/wpkg/rapports", $acls);

    set_samba_param("install", "acl allow execute always", "Yes");
    set_samba_param("rapports", "path", "/var/sambaedu/unattended/install/wpkg/rapports");
    set_samba_param("rapports", "read only", "no");

    // Modif du param
    set_config($config, 'acl_init', '1');
}

if (isset($_POST["ignoreWawadebMD5"]))
    $ignoreWawadebMD5 = $purifier->purify($_POST["ignoreWawadebMD5"]) + 0;
else
    $ignoreWawadebMD5 = 0;
if (isset($_POST["noDownload"]))
    $noDownload = $purifier->purify($_POST["noDownload"]) + 0;
else
    $noDownload = 0;

$page_id = 0;
include ("depot_top.php");

include ("pdp.inc.php");
?>