<?php
/**
 * Maintenance gestion des depots

 * @Projet LCS / SambaEdu
 * @auteurs  Laurent Joly
 * @note
 * @Licence Distribue sous la licence GPL
 */

// loading libs and init
	include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("lang.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
echo header_authorize($config);
	include "ihm.inc.php";
	include "wpkg_lib.php";
	include "wpkg_libsql.php";

	$login = $config['login'];
	if (! $login) {
		echo "<script language=\"JavaScript\" type=\"text/javascript\">\n<!--\n";
		$request = '/wpkg/index.php';
		echo "top.location.href = '/auth.php?request=" . rawurlencode($request) . "';\n";
		echo "//-->\n</script>\n";
		exit();
	}

	if (! have_right($config, "computer_is_admin"))
		die(gettext("Vous n'avez pas les droits suffisants pour acc&#233;der &#224; cette fonction") . "</BODY></HTML>");

	// HTMLpurifier
	$conf = HTMLPurifier_Config::createDefault();
	$purifier = new HTMLPurifier($conf);

	$page_id=3;
	include("maintenance_top.php");

	if (isset($_POST["action"]))
		$action = $purifier->purify($_POST["action"]);
	else
		$action = "";

	if ($action=="actif")
	{
		if (isset($_POST["id_depot"]))
			$id_depot = $purifier->purify($_POST["id_depot"]) + 0;
		else
			$id_depot = 0;
		if (isset($_POST["depot_actif"]))
			$depot_actif = $purifier->purify($_POST["depot_actif"]) + 0;
		else
			$depot_actif = 0;
		if ($id_depot!=0)
		{
			$return=update_depot_activation($config,$id_depot,$depot_actif);
			if ($return)
				echo "Modification effectuée<br><br>\n";
		}
	}
	elseif ($action=="principal")
	{
		if (isset($_POST["depot_principal"]))
			$depot_principal = $purifier->purify($_POST["depot_principal"]) + 0;
		else
			$depot_principal = 0;
		if ($depot_principal!=0)
		{
			$return=update_depot_principal($config,$depot_principal);
			if ($return)
				echo "Modification effectuée<br><br>\n";
		}
	}

	$list_depot=info_all_depot($config);

	echo "<table cellspacing=1 cellpadding=1 bgcolor='black' border=0 align='center' width='80%'>\n";
	echo "<tr>\n";
	echo "<th style='color:white' width='35'>Id</th>\n";
	echo "<th style='color:white'>Nom</th>\n";
	echo "<th style='color:white'>Url du dépôt</th>\n";
	echo "<th style='color:white' width='70'>Actif</th>\n";
	echo "</tr>\n";
	$echo_liste_depot_principal="";
	foreach ($list_depot as $ld)
	{
		echo "<tr bgcolor='white'>\n";
		echo "<td align='center'>".$ld["id_depot"]."</td>\n";
		echo "<td>".$ld["nom_depot"]."</td>\n";
		echo "<td>".$ld["url_depot"]."</td>\n";

		if ($ld["depot_principal"]==0)
		{
			echo "<form method='post' action=''>\n";
			echo "<td ";
			if ($ld["depot_actif"])
				echo "bgcolor='".$ok_bg."' style='color:".$ok_txt."' ";
			else
				echo "bgcolor='".$warning_bg."' style='color:".$warning_txt."' ";
			echo "align='center'>\n";
			echo "<input type='hidden' name='id_depot' value='".$ld["id_depot"]."'>\n";
			echo "<input type='hidden' name='action' value='actif'>\n";
			echo "<select name='depot_actif' onchange='submit()'>";
			echo "<option value=0";
			if ($ld["depot_actif"]==0)
				echo " selected";
			echo ">Non</option>";
			echo "<option value=1";
			if ($ld["depot_actif"]==1)
				echo " selected";
			echo ">Oui</option>";
			echo "</select>\n";
			echo "</td>\n";
			echo "</form>\n";
		}
		else
		{
			echo "<td ";
			if ($ld["depot_actif"])
				echo "bgcolor='".$ok_bg."' style='color:".$ok_txt."' ";
			else
				echo "bgcolor='".$warning_bg."' style='color:".$warning_txt."' ";
			echo "align='center'>\n";
			if ($ld["depot_actif"])
				echo "Oui";
			else
				echo "Non";
			echo "</td>\n";
		}

		if ($ld["depot_actif"])
		{
			$echo_liste_depot_principal .= "<option value='".$ld["id_depot"]."'";
			if ($ld["depot_principal"]==1)
				$echo_liste_depot_principal .= " selected";
			$echo_liste_depot_principal .= ">".$ld["nom_depot"]." (".$ld["id_depot"].")</option>";
		}

		echo "</tr>\n";
	}
	echo "</table>\n";

	echo "<form method='post' action=''>\n";
	echo "<p align='center'>\n";
	echo "Dépôt principal : \n";
	echo "<input type='hidden' name='action' value='principal'>\n";
	echo "<select name='depot_principal' onchange='submit()'>\n";
	echo $echo_liste_depot_principal;
	echo "</select>\n";
	echo "</p>\n";
	echo "</form>\n";

	include ("pdp.inc.php");
?>
