<?php
/**
 * Maintenance gestion des postes

 * @Projet LCS / SambaEdu
 * @auteurs  Laurent Joly
 * @note
 * @Licence Distribue sous la licence GPL
 */

// loading libs and init
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("lang.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
echo header_authorize($config);
include "ihm.inc.php";
include "wpkg_lib.php";
include "wpkg_libsql.php";

$login = $config['login'];
if (! $login) {
    echo "<script language=\"JavaScript\" type=\"text/javascript\">\n<!--\n";
    $request = '/wpkg/index.php';
    echo "top.location.href = '/auth.php?request=" . rawurlencode($request) . "';\n";
    echo "//-->\n</script>\n";
    exit();
}

if (! have_right($config, "computer_is_admin"))
    die(gettext("Vous n'avez pas les droits suffisants pour acc&#233;der &#224; cette fonction") . "</BODY></HTML>");

// HTMLpurifier
$conf = HTMLPurifier_Config::createDefault();
$purifier = new HTMLPurifier($conf);

if (isset($_GET["tri"]))
    $tri = $purifier->purify($_GET["tri"]) + 0;
else
    $tri = 0;
if (isset($_GET['flag']))
    $get_flag = $purifier->purify($_GET['flag']);
else
    $get_flag = -1;
if (isset($_GET['uuid']))
    $get_uuid = $purifier->purify($_GET['uuid']);
else
    $get_uuid = -1;

if (isset($_POST["valider"]))
    $post_valider = $purifier->purify($_POST["valider"]);
else
    $post_valider = "";


	$page_id=1;
	include("maintenance_top.php");


if ($post_valider == "Valider les modifications")
{
	if (isset($_POST["poste_id"]))
        $post_poste_id = $_POST["poste_id"];
    else
        $post_poste_id = array();
	
	
	if (isset($_POST["action"]))
		$post_action = $purifier->purify($_POST["action"])+0;
	else
		$post_action = 0;
	
	echo "<p align='left'>";
	$count=0;
    switch($post_action)
	{
		case 0:
			echo "<b><i>Aucune action</i></b>";
			break;
		case 1:
			echo "<b><i>Protection des machines :</i></b> ";
			foreach ($post_poste_id as $tmp)
			{
				$result=maintenance_poste_protection($config,$tmp);
				if ($result)
				{
					if ($count==0)
						$count=1;
					else
						echo ", ";
					echo $result;
				}
			}
			break;
		case 2:
			echo "<b><i>D&#233;protection des machines :</i></b> ";
			foreach ($post_poste_id as $tmp)
			{
				$result=maintenance_poste_deprotection($config,$tmp);
				if ($result)
				{
					if ($count==0)
						$count=1;
					else
						echo ", ";
					echo $result;
				}
			}
			break;
		case 3:
			echo "<b><i>Suppression des machines sans uuid :</i></b> ";
			foreach ($post_poste_id as $tmp)
			{
				$result=maintenance_poste_suppression($config,$tmp);
				if ($result)
				{
					if ($count==0)
						$count=1;
					else
						echo ", ";
					echo $result;
				}
			}
			break;
		case 4:
			echo "<b><i>Recharger le dernier rapport wpkg des machines :</i></b> ";
			foreach ($post_poste_id as $tmp)
			{
				$result=maintenance_poste_reset_wpkg($config,$tmp);
				if ($result)
				{
					if ($count==0)
						$count=1;
					else
						echo ", ";
					echo $result;
				}
			}
			break;
		case 5:
			echo "<b><i>Aucune action</i></b>";
			break;
		case 6:
			echo "<b><i>Aucune action</i></b>";
			break;
	}
	echo "</p></ br>";
}	

echo "<script>\n";
echo "function checkAll()\n";
echo "{\n";
echo "     var checkboxes = document.getElementsByTagName('input'), val = null; \n";
echo "     for (var i = 0; i < checkboxes.length; i++)\n";
echo "     {\n";
echo "        if (checkboxes[i].type == 'checkbox')\n";
echo "        {\n";
echo "            if (val === null) val = checkboxes[i].checked;\n";
echo "            checkboxes[i].checked = val;\n";
echo "        }\n";
echo "    }\n";
echo " }\n";
echo "</script>\n";

$liste_poste=maintenance_liste_poste($config,$get_flag,$get_uuid);

$tri_poste = array();
$tri_flag = array();
$tri_date = array();
$tri_ip = array();
$tri_mac = array();
$tri_nb_app = array();

foreach ($liste_poste as $key => $row) {
    $tri_poste[] = $key;
    $tri_flag[] = $row["flag_poste"];
    $tri_date[] = $row["date_modification_poste"];
    $tri_ip[] = ip2long($row["IP_poste"]);
    $tri_mac[] = $row["mac_address_poste"];
    $tri_nb_app[] = $row["nb_appli_installed"];
}

if ($liste_poste) {
    switch ($tri) {
        case 0:
            array_multisort($tri_poste, SORT_ASC, $liste_poste);
            break;
        case 1:
            array_multisort($tri_poste, SORT_DESC, $liste_poste);
            break;
        case 2:
            array_multisort($tri_flag, SORT_ASC, $tri_poste, SORT_ASC, $liste_poste);
            break;
        case 3:
            array_multisort($tri_flag, SORT_DESC, $tri_poste, SORT_ASC, $liste_poste);
            break;
        case 4:
            array_multisort($tri_nb_app, SORT_DESC, $tri_poste, SORT_ASC, $liste_poste);
            break;
        case 5:
            array_multisort($tri_nb_app, SORT_ASC, $tri_poste, SORT_ASC, $liste_poste);
            break;
        case 6:
            array_multisort($tri_date, SORT_DESC, $tri_poste, SORT_ASC, $liste_poste);
            break;
        case 7:
            array_multisort($tri_date, SORT_ASC, $tri_poste, SORT_ASC, $liste_poste);
            break;
        case 8:
            array_multisort($tri_ip, SORT_ASC, $liste_poste);
            break;
        case 9:
            array_multisort($tri_ip, SORT_DESC, $liste_poste);
            break;
        case 10:
            array_multisort($tri_mac, SORT_ASC, $liste_poste);
            break;
        case 11:
            array_multisort($tri_mac, SORT_DESC, $liste_poste);
            break;
        default:
            array_multisort($tri_poste, SORT_ASC, $liste_poste);
            break;
    }
}

echo "<table cellspadding='2' cellspacing='1' border='0' align='center' bgcolor='black'>\n";
echo "<tr style='color:white'>\n";
echo "<th width='10' rowspan='2'></th>\n";
echo "<th width='120' rowspan='2'><a href='?flag=".$get_flag."&uuid=".$get_uuid."&tri=";
if ($tri == 0)
    echo "1";
else
    echo "0";
echo "' style='color:" . $regular_lnk . "'>Nom du poste</a></th>\n";
echo "<th width='50' rowspan='2'>OS</th>\n";
echo "<th width='120'><a href='?flag=".$get_flag."&uuid=".$get_uuid."&tri=";
if ($tri == 2)
    echo "3";
else
    echo "2";
echo "' style='color:" . $regular_lnk . "'>Statut</a></th>\n";
echo "<th width='180' colspan='2'>Nombre d'applications</th>\n";
echo "<th width='200' rowspan='2'><a href='?flag=".$get_flag."&uuid=".$get_uuid."&tri=";
if ($tri == 6)
    echo "7";
else
    echo "6";
echo "' style='color:" . $regular_lnk . "'>Date du dernier rapport</a></th>\n";
echo "<th width='120' rowspan='2'><a href='?flag=".$get_flag."&uuid=".$get_uuid."&tri=";
if ($tri == 8)
    echo "9";
else
    echo "8";
echo "' style='color:" . $regular_lnk . "'>Adresse IP</a></th>\n";
echo "<th width='160' rowspan='2'><a href='?flag=".$get_flag."&uuid=".$get_uuid."&tri=";
if ($tri == 10)
    echo "11";
else
    echo "10";
echo "' style='color:" . $regular_lnk . "'>Adresse mac</a></th>\n";
echo "<th width='320'>Uuid machine</a></th>\n";
echo "</tr>\n";


echo "<form method='get' action=''>\n";
echo "<tr style='color:white'>\n";
echo "<th>";
echo " <select name='flag' onchange='submit()'>";
echo "  <option value='-1'";
if ($get_flag==-1)
	echo " selected";
echo ">Tout</option>";
echo "  <option value='0'";
if ($get_flag==0)
	echo " selected";
echo ">Non prot&#233;g&#233;</option>";
echo "  <option value='1'";
if ($get_flag==1)
	echo " selected";
echo ">Prot&#233;g&#233;</option>";
echo "  <option value='2'";
if ($get_flag==2)
	echo " selected";
echo ">Autre</option>";
echo " </select>";
echo "</th>\n";
echo "<th width='90'>Total</th>\n";
echo "<th width='90'><a href='?flag=".$get_flag."&uuid=".$get_uuid."&tri=";
if ($tri == 4)
    echo "5";
else
    echo "4";
echo "' style='color:" . $regular_lnk . "'>Install&#233;es</a></th>\n";
echo "<th>";
echo " <select name='uuid' onchange='submit()'>";
echo "  <option value='-1'";
if ($get_uuid==-1)
	echo " selected";
echo ">Tout</option>";
echo "  <option value='0'";
if ($get_uuid==0)
	echo " selected";
echo ">Inconnu</option>";
echo "  <option value='1'";
if ($get_uuid==1)
	echo " selected";
echo ">Connu</option>";
echo " </select>";
echo "</th>\n";
echo "</tr>\n";
echo "<input type='hidden' name='tri' value='" . $tri . "'>\n";
echo "</form>\n";

echo "<tr>\n";
echo "<td colspan='10'>\n";
echo "<table cellspadding='2' cellspacing='1' border='0' align='center' bgcolor='white' width='100%'>\n";
echo "<form method='post' action='?tri=" . $tri . "&flag=" . $get_flag . "&uuid=" . $get_uuid . "'>\n";
echo "<tr>\n";
echo "<td width='33%' style='color:black' align='center'>";
echo "<select name='action' style='color:white;background-color:red'>";
echo "<option value='0'>-- Choisir une action --</option>";
echo "<option value='1'>Prot&#233;ger des machines</option>";
echo "<option value='2'>D&#233;prot&#233;ger des machines</option>";
echo "<option value='3'>Supprimer des machines sans uuid</option>";
echo "<option value='4'>Recharger le dernier rapport wpkg</option>";
echo "<option value='5'>Rien</option>";
echo "</select>";
echo "</td>\n";
echo "<td width='33%' style='color:black' align='center'>";
echo "<input type='checkbox' onchange='checkAll()' name='chk[]' /> Tous/Aucun";
echo "</td>\n";
echo "<td width='*' style='color:black' align='center'>";
echo "<input type='submit' name='valider' value='Valider les modifications' style='color:white;background-color:red'>";
echo "</td>\n";
echo "</tr>\n";
echo "</table>\n";
echo "</td>\n";
echo "</tr>\n";



foreach ($liste_poste as $nom_poste => $lp)
{
    $affichage = 0;
    switch ($lp["flag_poste"]) {
        case 0:
            $bg = $ok_bg;
            $lnk = $ok_lnk;
            $txt = $ok_txt;
            $affichage = 1;
            break;
        case 1:
            $bg = $error_bg;
            $lnk = $error_lnk;
            $txt = $error_txt;
            $affichage = 1;
            break;
        case 2:
            $bg = $warning_bg;
            $lnk = $warning_lnk;
            $txt = $warning_txt;
            $affichage = 1;
            break;
    }
    if ($affichage == 1)
	{
        echo "<tr bgcolor='" . $bg . "' style='color: " . $txt . "'>";
	    echo "<td align='center'>";
		echo "<input type='checkbox' id='poste_id[]' name='poste_id[]' value='" . $lp["id"] . "' />";
		echo "</td>";
        echo "<td align='center'><a href='poste_statuts.php?id_host=" . $nom_poste . "' style='color: " . $lnk . "'>" . $nom_poste . "</a></td>";
        echo "<td align='center' bgcolor='" . $wintype_txt . "'>";
        echo '<img src="images/';
        switch ($lp["OS_poste"]) {
            case 'Windows XP':
                echo "winxp.png";
                break;
            case 'Windows 7':
                echo "win7.png";
                break;
            case 'Windows 10':
                echo "win10.png";
                break;
            default:
                echo "vide.png";
                break;
        }
        echo '" width="20" height="20">';
        echo "</td>";
        echo "<td align='center'>";
        switch ($lp["flag_poste"]) {
            case 0:
                echo "Non prot&#233;g&#233;";
                break;
            case 1:
                echo "Prot&#233;g&#233;";
                break;
            case 2:
                echo "Autre";
                break;
        }
        echo "</td>";
        echo "<td align='center'>" . $lp["nb_appli"] . "</td>";
        echo "<td align='center'>" . $lp["nb_appli_installed"] . "</td>";
		$rapport_date = date('d/m/Y', strtotime($lp["date_modification_poste"]));
		$rapport_time = date('H:i:s', strtotime($lp["date_modification_poste"]));
        echo "<td align='center'><a href='log.php?logfile=" . $lp["file_log_poste"] . "' target='rapport_poste' style='color: " . $lnk . "'>" . $rapport_date . " &#224; " . $rapport_time . "</a></td>";
        echo "<td align='center'>" . $lp["IP_poste"] . "</td>";
        echo "<td align='center'>" . $lp["mac_address_poste"] . "</td>";
        echo "<td align='center'>" . $lp["uuid_poste"] . "</td>";
        echo "</tr>\n";
    }
}
echo "</table>\n";
echo "</form>\n";

include ("pdp.inc.php");
?>
