<?php
/**
 * Importation des applications depuis les differents depots enregistres
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @auteurs  Laurent Joly
 * @note
 * @Licence Distribue sous la licence GPL
 */
// loading libs and init
include "config.inc.php";
$config = get_config();
include ("wpkg_libsql.php");

$liste_depot = info_depot($config);

foreach ($liste_depot as $ld) {
    require_once (dirname(__FILE__) . '/../vendor/autoload.php');
    curl_proxy_options($config, $opt);
    $client = new GuzzleHttp\Client($opt);
    try {
        $file = "/tmp/" . basename($ld["url_depot"]);
        $client->request('GET', $ld["url_depot"], ["sink" => $file]);
        if (file_exists($file)) {
            $hash_xml = hash_file('sha256', $file);
            if ($hash_xml != $ld["hash_xml"]) {
                desactive_depot_applis($config, $ld["id_depot"]);
                $xml = new DOMDocument();
                $xml->formatOutput = true;
                $xml->preserveWhiteSpace = false;
                $xml->load($file);
                $branchs = $xml->documentElement->getElementsByTagName('branch');
                foreach ($branchs as $branch) {
                    $packages = $branch->getElementsByTagName('package');
                    foreach ($packages as $package) {
                        $compatibilite = (string) $package->getAttribute('compatibilite');
                        $compatibilite = intval($compatibilite);
                        $tab = array();
                        $tab = array(
                            "id_nom_app" => (string) $package->getAttribute('id'),
                            "nom_app" => (string) $package->getAttribute('name'),
                            "xml" => (string) $package->getAttribute('xml'),
                            "url_xml" => (string) $package->getAttribute('url'),
                            "sha_xml" => (string) $package->getAttribute('hash'),
                            "url_log" => (string) $package->getAttribute('log'),
                            "categorie" => (string) $package->getAttribute('category'),
                            "compatibilite" => $compatibilite,
                            "version" => (string) $package->getAttribute('revision'),
                            "branche" => (string) $branch->getAttribute('id'),
                            "date" => (string) $package->getAttribute('date'),
                            "id_depot" => $ld["id_depot"]
                        );
                        insert_appli_depot($config, $tab);
                    }
                }
                delete_depot_applis_inactives($config, $ld["id_depot"]);
                update_hash_depot($config, $ld["id_depot"], $hash_xml);
            }
        }
    } catch (GuzzleHttp\Exception\RequestException | GuzzleHttp\Exception\ConnectException $e) {
        echo "Impossible de télécharger la liste des applications WPKG : " . $e->getMessage();
    }
}
?>