<?php
include ("config.inc.php");
$config = get_config();
include ("ldap.inc.php");
include ("wpkg_libsql.php");
include ("wpkg_lib.php");

$success = false;
apcu_fetch('wpkg_lock', $success);
if ($success) {
    exit();
}
apcu_add('wpkg_lock', 1000);
$liste_postes = info_postes($config);
$liste_parcs = info_parcs($config);
$liste_hosts_ad = list_machines_parcs($config);
$liste_parcs_ad = search_parcs($config, "*");
$liste_postes_uuid = info_postes_uuid($config);
$mod = false;

if (empty($liste_parcs_ad) || empty($liste_hosts_ad)) {
    echo "<b>ERREUR</b> pas de connexion AD !<br>\n";
} else {
    $liste_parcs_ad[]['name'] = "_TousLesPostes";
    foreach ($liste_parcs_ad as $parc) {
        if (isset($liste_parcs[$parc["name"]]['id'])) {
            if (! isset($liste_parcs[$parc["name"]]['uuid']) && isset($parc["uuid"])) {
                update_parc($config, $liste_parcs[$parc["name"]]['id'], $parc["name"], $parc["uuid"]);
            }
            // echo "Le parc " . $parc["name"] . " existait déjà.<br>\n";
            unset($liste_parcs[$parc["name"]]);
        } else {
            $rename = false;
            foreach ($liste_parcs as $nom => $parc_wpkg) {
                if ($parc['uuid'] == $parc_wpkg['uuid']) {
                    update_parc($config, $parc_wpkg['id'], $parc["name"], $parc["uuid"]);
                    unset($liste_parcs[$nom]);
                    $rename = true;
                    echo "<b>Le parc " . $nom . " a été renommé " . $parc["name"] . ".</b><br>\n";
                    $mod = true;
                    break;
                }
            }
            if (! $rename) {
                $id_parc = insert_parc($config, $parc["name"], $parc['uuid']);
                $liste_parcs[$parc["name"]]["id"] = $id_parc;
                echo "<b>Le parc " . $parc["name"] . " a été créé.</b><br>\n";
                $mod = true;
                unset($liste_parcs[$parc["name"]]);
            }
        }
    }
    foreach ($liste_parcs as $parc) {
        delete_parc_wpkg($config, $parc["id"]);
        echo "<b>Le parc " . $parc["nom_parc"] . " a été effacé.</b><br>\n";
        $mod = true;
    }
    $liste_parcs = info_parcs($config);
    $liste_parcs_postes = info_postes_parcs($config);
    $liste_postes_original = $liste_postes;
    foreach ($liste_hosts_ad as $host_ad => $array_host_ad) {
        $host_ad = strtolower($host_ad);
        $parcs_ad = $array_host_ad["parc"];
        $host_guid = $array_host_ad["objectguid"];
        $wpkg_error = 0;
        if ($host_guid) {
            if (! isset($liste_postes_uuid[$host_guid])) {
                // uuid poste inconnu
                if (! isset($liste_postes_original[$host_ad])) {
                    // nom poste inconnu
                    $info = array(
                        "nom_poste" => $host_ad,
                        "datetime" => "2000-01-01 00:00:00",
                        "mac_address" => "",
                        "ip" => "",
                        "logfile" => "",
                        "rapportfile" => "",
                        "sha256" => "",
                        "typewin" => "",
                        "flag_poste" => 0,
                        "uuid_poste" => $host_guid
                    );
                    $id_poste = insert_poste_info_wpkg($config, $info);
                    $liste_postes[$host_ad]["id"] = $id_poste;
                    $liste_postes_original[$host_ad] = array(
                        "id" => $id_poste,
                        "uuid_poste" => $host_guid
                    );
                    $liste_postes_uuid[$host_guid] = array(
                        "id" => $id_poste,
                        "nom_poste" => $host_ad,
                        "uuid_poste" => $host_guid,
                        "flag_poste" => 0
                    );
                    $liste_postes_uuid[$host_guid]["check_poste"] = 1;
                    echo "<b>Le poste " . $host_ad . " a été créé avec l'id " . $id_poste . ".</b><br>\n";
                } else {
                    // nom poste connu
                    if (is_null($liste_postes_original[$host_ad]["uuid_poste"])) {
                        // aucun uuid pour ce poste
                        update_poste_uuid_wpkg($config, $liste_postes_original[$host_ad]["id"], $host_guid, 0);
                        $liste_postes_original[$host_ad]["uuid_poste"] = $host_guid;
                        $liste_postes_uuid[$host_guid] = array(
                            "id" => $liste_postes_original[$host_ad]["id"],
                            "nom_poste" => $host_ad,
                            "uuid_poste" => $host_guid,
                            "flag_poste" => 0
                        );
                        $liste_postes_uuid[$host_guid]["check_poste"] = 1;
                        echo "<b>Le poste " . $host_ad . " a désormais un uid : " . $host_guid . ".</b><br>\n";
                    } else {
                        // ce poste possede deja un uuid
                        if (isset($liste_postes_uuid[$liste_postes_original[$host_ad]["uuid_poste"]]["check_poste"])) {
                            $check_poste_wpkg = $liste_postes_uuid[$liste_postes_original[$host_ad]["uuid_poste"]]["check_poste"];
                        } else {
                            $check_poste_wpkg = 0;
                        }
                        if ($check_poste_wpkg == 0) {
                            // l uuid peut etre change
                            update_poste_uuid_wpkg($config, $liste_postes_original[$host_ad]["id"], $host_guid, 0);
                            $liste_postes_original[$host_ad]["uuid_poste"] = $host_guid;
                            $liste_postes_uuid[$host_guid] = array(
                                "id" => $liste_postes_original[$host_ad]["id"],
                                "nom_poste" => $host_ad,
                                "uuid_poste" => $host_guid,
                                "flag_poste" => 0
                            );
                            $liste_postes_uuid[$host_guid]["check_poste"] = 1;
                            echo "<b>Le poste " . $host_ad . " a changé d'uid : " . $host_guid . ".</b><br>\n";
                        } else {
                            // changement du nom de poste impossible
                            echo "<font color='red'><b>Conflit d'UID (1). Ce poste a déjà un autre uid. Une intervention est nécessaire.</b></font><br>";
                            $wpkg_error = 1;
                        }
                    }
                }
            } else {
                // uuid poste connu
                if ($liste_postes_uuid[$host_guid]["nom_poste"] == $host_ad) {
                    // nom du poste identique
                    // echo "Le poste ".$host_ad." existe déjà.<br>";
                    $liste_postes_uuid[$host_guid]["check_poste"] = 1;
                } else {
                    // nom du poste incorrect
                    if (! isset($liste_postes_original[$host_ad])) {
                        // nom du poste disponible
                        if (file_exists($wpkgroot . '/rapports/' . $liste_postes_original[$liste_postes_uuid[$host_guid]["nom_poste"]]["file_log_poste"])) {
                            unlink($wpkgroot . '/rapports/' . $liste_postes_original[$liste_postes_uuid[$host_guid]["nom_poste"]]["file_log_poste"]);
                        }
                        if (file_exists($wpkgroot . '/rapports/' . $liste_postes_original[$liste_postes_uuid[$host_guid]["nom_poste"]]["file_rapport_poste"])) {
                            unlink($wpkgroot . '/rapports/' . $liste_postes_original[$liste_postes_uuid[$host_guid]["nom_poste"]]["file_rapport_poste"]);
                        }
                        update_poste_nom_wpkg($config, $liste_postes_uuid[$host_guid]["id"], $host_ad);
                        $liste_postes[$host_ad] = $liste_postes[$liste_postes_uuid[$host_guid]["nom_poste"]];
                        $liste_postes_original[$host_ad] = array(
                            "id" => $liste_postes_uuid[$host_guid]["id"],
                            "uuid_poste" => $host_guid
                        );
                        unset($liste_postes[$liste_postes_uuid[$host_guid]["nom_poste"]]);
                        unset($liste_postes_original[$liste_postes_uuid[$host_guid]["nom_poste"]]);
                        $liste_postes_uuid[$host_guid]["check_poste"] = 1;
                        echo "<b>Le poste " . $liste_postes_uuid[$host_guid]["nom_poste"] . " a été renommé " . $host_ad . ".</b><br>\n";       
                        $mod = true; 
                    } else {
                        // nom du poste deja pris
                        if (is_null($liste_postes_original[$host_ad]["uuid_poste"])) {
                            $check_poste_wpkg = 0;
                        } elseif (isset($liste_postes_uuid[$liste_postes_original[$host_ad]["uuid_poste"]]["check_poste"])) {
                            $check_poste_wpkg = $liste_postes_uuid[$liste_postes_original[$host_ad]["uuid_poste"]]["check_poste"];
                        } else {
                            $check_poste_wpkg = 0;
                        }
                        if ($check_poste_wpkg == 0) {
                            // le nom peut etre change
                            if (file_exists($wpkgroot . '/rapports/' . $liste_postes_original[$host_ad]["file_log_poste"])) {
                                unlink($wpkgroot . '/rapports/' . $liste_postes_original[$host_ad]["file_log_poste"]);
                            }
                            if (file_exists($wpkgroot . '/rapports/' . $liste_postes_original[$host_ad]["file_rapport_poste"])) {
                                unlink($wpkgroot . '/rapports/' . $liste_postes_original[$host_ad]["file_rapport_poste"]);
                            }
                            if (file_exists($wpkgroot . '/rapports/' . $liste_postes_original[$liste_postes_uuid[$host_guid]["nom_poste"]]["file_log_poste"])) {
                                unlink($wpkgroot . '/rapports/' . $liste_postes_original[$liste_postes_uuid[$host_guid]["nom_poste"]]["file_log_poste"]);
                            }
                            if (file_exists($wpkgroot . '/rapports/' . $liste_postes_original[$liste_postes_uuid[$host_guid]["nom_poste"]]["file_rapport_poste"])) {
                                unlink($wpkgroot . '/rapports/' . $liste_postes_original[$liste_postes_uuid[$host_guid]["nom_poste"]]["file_rapport_poste"]);
                            }
                            update_poste_nom_wpkg($config, $liste_postes_original[$host_ad]["id"], $host_ad . "-" . date("Ymd-His"));
                            $liste_postes[$host_ad . "-" . date("Ymd-His")] = $liste_postes[$host_ad];
                            $liste_postes_original[$host_ad . "-" . date("Ymd-His")] = $liste_postes_original[$host_ad];
                            echo "<b>Le poste " . $host_ad . " a été renommé " . $host_ad . "-" . date("Ymd-His") . ".</b><br>\n";
                            update_poste_nom_wpkg($config, $liste_postes_uuid[$host_guid]["id"], $host_ad);
                            $liste_postes[$host_ad] = $liste_postes[$liste_postes_uuid[$host_guid]["nom_poste"]];
                            $liste_postes_original[$host_ad] = array(
                                "id" => $liste_postes_uuid[$host_guid]["id"],
                                "uuid_poste" => $host_guid
                            );
                            unset($liste_postes[$liste_postes_uuid[$host_guid]["nom_poste"]]);
                            unset($liste_postes_original[$liste_postes_uuid[$host_guid]["nom_poste"]]);
                            $liste_postes_uuid[$host_guid]["check_poste"] = 1;
                            echo "<b>Le poste " . $liste_postes_uuid[$host_guid]["nom_poste"] . " a été renommé " . $host_ad . ".</b><br>\n";
                            $mod = true;
                        } else {
                            // changement du nom de poste impossible
                            echo "<font color='red'><b>Conflit d'UID (2). Ce poste a déjà un autre uid. Une intervention est nécessaire.</b></font><br>";
                            $wpkg_error = 1;
                        }
                    }
                }
            }
            if ($wpkg_error == 0) {
                if (isset($liste_parcs_postes[$liste_postes[$host_ad]["id"]])) {
                    $liste_poste_parc_sql = $liste_parcs_postes[$liste_postes[$host_ad]["id"]];
                } else {
                    $liste_poste_parc_sql = array();
                }
                if (isset($liste_postes[$host_ad])) {
                    $parcs_ad[] = "_TousLesPostes";
                    foreach ($parcs_ad as $parc) {
                        if (isset($liste_poste_parc_sql[$parc])) {
                            // echo "Le poste ".$host_ad." est déjà dans le parc ".$parcs["name"].".<br>";
                            unset($liste_poste_parc_sql[$parc]);
                        } else {
                            insert_parc_profile($config, $liste_postes[$host_ad]["id"], $liste_parcs[$parc]["id"]);
                            echo "<b>Le poste " . $host_ad . " a été ajouté au parc " . $parc . ".</b><br>\n";
                            $mod = true;
                        }
                    }
                }
                foreach ($liste_poste_parc_sql as $parc) {
                    if (isset($parc["id_parc"])) {
                        delete_parc_profile($config, $liste_postes[$host_ad]["id"], $liste_parcs[$parc["nom_parc"]]["id"]);
                        echo "<b>Le poste " . $host_ad . " a été supprimé du parc " . $parc["nom_parc"] . ".</b><br>\n";
                        $mod = true;
                    }
                }
            }
            unset($liste_postes[$host_ad]);
        }
    }
    foreach ($liste_postes as $poste) {
        if (isset($poste["id"]))
        {
            if ($poste["flag_poste"]==0)
            {
                if (file_exists($wpkgroot . '/rapports/' . $poste["file_log_poste"]))
                {
                    unlink($wpkgroot . '/rapports/' . $poste["file_log_poste"]);
                    echo "Suppression du rapport ".$poste["file_log_poste"].".<br>";
                }
                if (file_exists($wpkgroot . '/rapports/' . $poste["file_rapport_poste"]))
                {
                    unlink($wpkgroot . '/rapports/' . $poste["file_rapport_poste"]);
                    echo "Suppression du rapport ".$poste["file_rapport_poste"].".<br>";
                }
                delete_poste_info_wpkg($config, $poste["id"]);
                echo "<b>Le poste ".$poste["nom_poste"]." a été supprimé.</b><br>";
                $mod = true;
            }
            else
            {
                $parc_ad = "_TousLesPostes";
                $liste_poste_parc_sql = info_poste_parcs($config, $poste["nom_poste"]);
                if (isset($liste_poste_parc_sql[$parc_ad]))
                {
                    //echo "Le poste ".$poste["nom_poste"]." est déjà dans le parc ".$parc_ad.".<br>";
                    unset($liste_poste_parc_sql[$parc_ad]);
                }
                else
                {
                    insert_parc_profile($config, $poste["id"], $liste_parcs[$parc_ad]["id"]);
                    echo "<b>Le poste " . $poste["nom_poste"] . " a été ajouté au parc " . $parc_ad . ".</b><br>\n";
                    $mod = true;
                }
                foreach ($liste_poste_parc_sql as $parc)
                {
                    if (isset($parc["id_parc"]))
                    {
                        delete_parc_profile($config, $poste["id"], $liste_parcs[$parc["nom_parc"]]["id"]);
                        echo "<b>Le poste " . $poste["nom_poste"] . " a été supprimé du parc " . $parc["nom_parc"] . ".</b><br>\n";
                        $mod = true;
                    }
                }
            }
        }
    }
    if ($mod){
//        apcu_delete(new APCUIterator('#^wpkg_#'));
    }
}
apcu_delete('wpkg_lock');
?>
