<?php
include ("config.inc.php");
$config = get_config();
include ("wpkg_libsql.php");
include ("logs.inc.php");

$success = false;
apcu_fetch('rapports_wpkg_lock', $success);
if ($success) {
    header($_SERVER["SERVER_PROTOCOL"]." 403 lecture des rapports en cours"); 
    exit();
}

$rapport_repertoire = "/var/sambaedu/unattended/install/wpkg/rapports/";

if (! is_dir($rapport_repertoire)){
    exit();
}
apcu_store('rapports_wpkg_lock', 200);

$liste_rapport = array();
$iterator = new DirectoryIterator($rapport_repertoire);
foreach ($iterator as $fichier) {
    if (($fichier->getExtension()) == "txt") {
        $liste_rapport[] = $fichier->getFilename();
    }
}

sort($liste_rapport);

$liste_postes = info_postes($config);
$liste_app = liste_applications($config);
$info_sha_postes = info_sha_postes($config);

// Gestion de tous les rapports
foreach ($liste_rapport as $rapport_fichier) {
    // Gestion de chaque rapport
    $rapport_txt = @fopen($rapport_repertoire . $rapport_fichier, "r");
    $uptodate = 0;
    $sha256_file = hash_file('sha256', $rapport_repertoire . $rapport_fichier);
    if ($rapport_txt) {
        if (! isset($info_sha_postes[$rapport_fichier])) {
            $uptodate = - 1;
        } else if ($info_sha_postes[$rapport_fichier] == $sha256_file) {
            $uptodate = 1;
        } else {
            $uptodate = 0;
        }

        if ($uptodate != 1) {
            echo "rapport pour $rapport_fichier\n";
            $ligne = 0;
            $id_app = 0;
            $id_poste = 0;
            $info = array();
            while (($rapport_ligne = fgets($rapport_txt)) !== false) {
                if ($ligne == 0) {
                    $rapport_ligne_data = explode(" ", $rapport_ligne);
                    $m = [];
                    preg_match("/([0-9]*\.[0-9]*\.[0-9]*\.[0-9]*)/", substr($rapport_ligne_data[4], 1), $m);
                    $ip = $m[1] ?? "";
                    $info = array(
                        "nom_poste" => $rapport_ligne_data[2],
                        "datetime" => substr($rapport_ligne_data[0], 6, 4) . "-" . substr($rapport_ligne_data[0], 3, 2) . "-" . substr($rapport_ligne_data[0], 0, 2) . " " . $rapport_ligne_data[1],
                        "mac_address" => $rapport_ligne_data[3],
                        "ip" => $ip,
                        "logfile" => $rapport_ligne_data[2] . ".log",
                        "rapportfile" => $rapport_fichier,
                        "sha256" => $sha256_file
                    );

                    if (strpos($info["ip"], "/") !== false) {
                        $info["ip"] = substr($info["ip"], 0, strpos($info["ip"], "/") - strlen($info["ip"]));
                    }
                    if (substr_count(strtolower($rapport_ligne), "windows 7") > 0)
                        $info["typewin"] = "Windows 7";
                    elseif (substr_count(strtolower($rapport_ligne), "windows 10") > 0)
                        $info["typewin"] = "Windows 10";
                    elseif (substr_count(strtolower($rapport_ligne), "winxp") > 0)
                        $info["typewin"] = "Windows XP";
                    else
                        $info["typewin"] = "Autre";
                    if ($uptodate == - 1) {
                        if (array_key_exists($info["nom_poste"], $liste_postes)) {
                            $id_poste = update_poste_info_wpkg($config, $info);
                        } else {
                            $id_poste = insert_poste_info_wpkg($config, $info);
                        }
                    } else {
                        $id_poste = update_poste_info_wpkg($config, $info);
                    }
                    $info = array();
                } else {
                    $rapport_ligne_data = explode(":", $rapport_ligne);
                    switch (ltrim($rapport_ligne_data[0])) {
                        case "ID":
                            $id_app ++;
                            $info[$id_app]["id_nom_app"] = rtrim(ltrim($rapport_ligne_data[1]));
                            break;
                        case "Revision":
                            $info[$id_app]["Revision"] = rtrim(ltrim($rapport_ligne_data[1]));
                            break;
                        case "Reboot":
                            $info[$id_app]["Reboot"] = rtrim(ltrim($rapport_ligne_data[1]));
                            if ($info[$id_app]["Reboot"] == "false")
                                $info[$id_app]["Reboot"] = 0;
                            else
                                $info[$id_app]["Reboot"] = 1;
                            break;
                        case "Status":
                            $info[$id_app]["Status"] = rtrim(ltrim($rapport_ligne_data[1]));
                            break;
                        default:
                            break;
                    }
                }
                $ligne ++;
            }
            delete_info_app_poste($config, $id_poste);
            if (count($info) > 0) {
                insert_mass_info_app_poste($config, $id_poste, $liste_app, $info);
                // log_connexion($config, "", $info['nom_poste'], "", "wpkg", "", SAMBAEDU_WPKG_RUNNING, true);
            }
        }
        fclose($rapport_txt);
    }
}
apcu_delete('rapports_wpkg_lock');
?>
